;;;; Jonathan Koren
;;;; Inspired by Rahsheen Porter's (rahsheen@linuxgeneralstore.com)
;;;; background hack and some other hack that was mailed to from the
;;;; saw(mill|fish) mailing list.  (Don't remember who though.)


;add these to ~/.sawmillrc
;
;(require 'backgrounds)
;(add-hook 'after-initialization-hook workspace-background-hook)
;(add-hook 'enter-workspace-hook      workspace-background-hook)
;(add-hook 'workspace-state-change-hook workspace-background-customize-hook)

(provide 'backgrounds)

(define workspace-symbols)

(defun set-background (wssym)
    (when background-enabled
        (system (concat background-set-app
                        " "
                        (cdr (assoc wssym workspace-backgrounds))
                        " &"))))

(defun workspace-background-hook ()
    (set-background (nth current-workspace workspace-symbols)))

(defun wsstrs2syms ()
"Returns a list of the workspace-names as symbols, instead of strings"
    (let ((syms workspace-names))
         (do ( (i (length syms) (length syms)) )
             ( (> (length syms) (cdr (workspace-limits)) ) )
             (setq syms (append syms
                                (list (format nil (_ "space %d") (+ i 1))))))
         (mapcar intern syms)))

(defun reassoc-ws (l)
"maps the elements of the list to be the keys of workspace-backgrounds
 (If rep supported setf then this could be abstracted."
    (let ((newback nil))
        (do ( (i 0 (1+ i)) )
            ( (> i (1- (length workspace-backgrounds))) )
            (setq newback (append newback
                                  (list (cons (nth i l)
				              (cdr (nth i workspace-backgrounds)))))))
       (setq workspace-backgrounds newback)))

;;;; Customization stuff
(defgroup background "Background")

(defcustom background-enabled nil
    "Enable Backgrounds"
    :type boolean
    :group background
    :after-set workspace-background-hook)

(defcustom background-set-app "Esetroot"
  "Application to set desktop background"
  :type program-name
  :group background
  :after-set workspace-background-hook)

;; HACK HACK
(defun workspace-background-customize-hook ()
    (setq workspace-symbols (wsstrs2syms))
    (reassoc-ws (wsstrs2syms))

    ; hack to update the workspace names
    (defcustom workspace-backgrounds nil
               "Workspace Backgrounds: \\w"
               :type* `(alist (,(cons 'symbol workspace-symbols)
                               ,(_ "Workspace"))
                              (file ,(_ "Graphic")))
               :group background
               :after-set workspace-background-hook))

;;;; go forth my pretty

(workspace-background-customize-hook)
