
;; rewrite-window-title.jl -- Rewrite the title of some windows

;; Copyright (C) 2000 Ian Campbell <ijc25@cam.ac.uk>

(provide 'window-title)

;; Configure the re-write rules.
;; First item is the regex to match, second is the replacement
(defvar ijc-rewrite-window-title-rules
  `( ("Netscape: (.*)" . "\\1 (Netscape)") ))

(defun ijc-rewrite-window-title (w)
  "Sets the title of certain windows"
  (let ((wn (get-x-text-property w 'WM_NAME) )
	(x ijc-rewrite-window-title-rules))
    (while x
      (when (string-match (car (car x)) (aref wn 0) )
	(aset wn 0 (expand-last-match (cdr (car x)) ))
	(setq x nil))
      (setq x (cdr x)))
    (set-x-text-property w 'WM_NAME wn)))

(defun ijc-window-property-changed (w an type)
  "property-notify-hook callback. Checks for WM_NAME being set"
  (when (and (eq an 'WM_NAME) (eq type 'new-value))
    (ijc-rewrite-window-title w)))

(add-hook 'property-notify-hook ijc-window-property-changed t)
(add-hook 'add-window-hook ijc-rewrite-window-title t)

