;; marks.jl - Provide a way to operate on multiple windows
;;
;; Author : Yann Hodique <Yann.Hodique@lifl.fr>

(define-structure sigma.marks

    (export sigma-marks-mark-window
            sigma-marks-unmark-window
            sigma-marks-unmark-all-windows
            sigma-marks-apply-on-marked-windows
            sigma-marks-marked-windows)

    (open rep)

  ;; Variable containing a list of marked windows
  (define sigma-marks-marked-windows-list nil)

  ;; Mark a window
  (define (sigma-marks-mark-window win)
    (interactive "%W")
    (setq sigma-marks-marked-windows-list (append sigma-marks-marked-windows-list (list win))))

  ;; Unmark a window
  (define (sigma-marks-unmark-window win)
    (interactive "%W")
    (setq sigma-marks-marked-windows-list (remove win sigma-marks-marked-windows-list)))

  ;; Clear the marked-windows vector
  (define (sigma-marks-unmark-all-windows)
    (interactive)
    (setq sigma-marks-marked-windows-list nil))

  ;; Apply a function on marked windows
  (define (sigma-marks-apply-on-marked-windows func)
    (mapcar func sigma-marks-marked-windows-list))

  ;; List of marked windows
  (define (sigma-marks-marked-windows)
    (not (eq sigma-marks-marked-windows-list nil)))

  )
